;OCP Print Files Generator 1.0
;(c) 1989 MJSoft System Software
;Martin Mares

;(OCP=>Writer/Tasword)

	org	60000
	ld	a,1
	ld	(blnr),a
	call	0d6bh
	ld	a,254
	call	1601h
	ld	de,tx1
	ld	bc,tx2-tx1
	call	203ch
	ld	hl,routs
	ld	de,16384
	ld	bc,rtend-routs
	ldir
	ld	hl,35501
	ld	ix,49152
	ld	de,0
loop	ld	a,(hl)
	cp	128
	jr	z,stop
	inc	hl
	inc	hl
	inc	hl
	inc	de
	ld	a,22
	rst	16
	ld	a,7
	rst	16
	ld	a,18
	rst	16
	call	linum
	call	space
	ld	bc,7
	call	zone
	ld	bc,5
	call	zone
	ld	bc,46
	call	zone
	jr	loop

routs	ld	bc,32765
	ld	d,17
	out	(c),d
	dec	d
	ld	(ix),e
	out	(c),d
	ret
rout2	ld	bc,32765
	ld	a,17
	out	(c),a
	push	bc
	ld	a,255
	scf
	call	04c2h
	pop	bc
	ld	a,16
	out	(c),a
	ret
rtend

stoby	equ	16384
sblo	equ	16384+rout2-routs

stop	ld	de,tx4
	ld	bc,tx5-tx4
	call	203ch
	push	ix
	pop	hl
	ld	a,h
	or	l
	cp	192
	ret	z
	jp	sblk

linum	push	hl
	push	de
	ex	de,hl
	ld	de,10000
	call	lnr1
	ld	de,1000
	call	lnr1
	ld	de,100
	call	lnr1
	ld	e,10
	call	lnr1
	ld	a,l
	call	lnr3
	pop	de
	pop	hl
	ret
lnr1	ld	b,255
lnr2	inc	b
	and	a
	sbc	hl,de
	jr	nc,lnr2
	add	hl,de
	ld	a,b
lnr3	add	a,48
	call	store
	rst	16
	ret

zone	ld	b,(hl)
	inc	hl
	ld	a,c
	sub	b
	jr	c,zo2
	cp	c
	ld	c,a
	jr	z,zofil
zo1	ld	a,(hl)
	inc	hl
	call	store
	djnz	zo1
zofil	ld	b,c
zof1	call	space
	djnz	zof1
	ret
zo2	ld	a,58
	sub	b
	ld	c,a
zo3	ld	a,(hl)
	inc	hl
	call	store
	djnz	zo3
	ld	b,c
zo4	call	space
	djnz	zo4
	inc	hl
	inc	hl
	pop	af
	jp	loop

space	ld	a,32
store	push	bc
	push	de
	push	hl
	ld	e,a
	call	stoby
	inc	ix
	db	0ddh
	ld	a,h
	or	a
	call	z,save
	ld	a,e
	pop	hl
	pop	de
	pop	bc
	ret

save	ld	hl,16384
	jr	sav1
sblk	push	ix
	pop	hl
	ld	de,49152
	and	a
	sbc	hl,de
sav1	ld	(hdln),hl
	ld	de,tx2
	ld	bc,tx3-tx2
	call	203ch
	ld	(iy-50),0
sav2	ld	a,(23560)
	or	a
	jr	z,sav2
	ld	(iy-50),0
	ld	de,tx3
	ld	bc,tx4-tx3
	call	203ch
	ld	hl,blnr
	ld	a,(hl)
	add	a,48
	ld	(hdnr),a
	inc	(hl)
	ld	ix,head
	ld	de,17
	xor	a
	call	04c2h
	ld	b,25
sav3	halt
	djnz	sav3
	ld	ix,49152
	ld	de,(hdln)
	call	sblo
	ld	ix,49152
	ret

tx1	db	22,5,0
	dm	'OCP->Writer'
	dm	' coneverter v1.0'
	db	13,13
	dm	'Transferring line '
tx2	db	22,20,0
	dm	'Start tape, then'
	dm	' press any key'
tx3	db	22,20,0
	dm	'                '
	dm	'                '
tx4	db	22,7,0
	dm	'Operation complete'
	dm	'd       '
tx5

blnr	db	1

head	db	3
	dm	'Source # '
hdnr	db	48
hdln	ds	2
	dw	32768
	dw	0
